
;******************************************************
.include "8515def.inc"	;  AT90S8515
.def temp=r16		; 
.def cols=r18		;  
			;
.def rots=r21		;  
.def key=r19		; 
.def scancod=r20	; 
.def lcd=r22		; LCD (-)
.def count_lcd=r23	;  
			; LCD
;     LCD
.equ rs=5	; (RS=1) - , (RS=0) - 
.equ rw=6	; (RW=1) -  LCD, (RW=0) -   LCD
.equ e=7	;    /

.org $000
	rjmp init
.org $007
	rjmp scankeys	; 

;
init:
	ldi temp,low(RAMEND) ;
	out spl,temp	     ; 
	ldi temp,high(RAMEND)
	out sph,temp
      ; 
	ser temp
	out DDRA,temp	     ;   
	out DDRC,temp	     ; C  
	ldi temp,$0F	     ;  PD0-PD3  ,
	out DDRD,temp	     ;PD4-PD7  
	ldi temp,$F0
	out PORTD,temp
      ;  0
	ldi temp,$05
	out TCCR0,temp	     ;  1024	
	ldi temp, (1<<TOIE0)
	out TIMSK, temp	     ;   
      ; -
	rcall delay2ms
	ldi lcd,$38		;8-  ,
	rcall lcdcom		;2 ,  57
	ldi lcd,$06
      ;   ,   
	rcall lcdcom
	ldi lcd,$0C		; 
	rcall lcdcom		; 
	ldi lcd,$01
      ;       
	rcall lcdcom
	rcall delay2ms
      ;      
      ; 
	ldi lcd,$80
	rcall lcdcom
	ldi count_lcd,12	;    
	ldi zl,low(str_0*2)   
	ldi zh,high(str_0*2)   
      out0: lpm
	adiw zl,1
	mov lcd,r0
	rcall lcddat
	dec count_lcd
	brne out0
      ;       
      ;
	ldi lcd,$C0
	rcall lcdcom
	ldi count_lcd,17
	sei			; 
      loop: rjmp loop

      ;  
      scankeys:
	clr key
	clr scancod
	ldi cols,2
	sec
     scan: rol scancod		;  -
	out PORTD,scancod	;  
	clc
	ldi rots,4
	in temp,PIND		;  
     mm: rol temp
	brcc nn			;  
	rjmp press		;   (=0)
     nn: inc key		;  
	dec rots		;  
	brne mm
	dec cols		;  
	brne scan
     press: cpi key,8
	breq f1			;   
	rcall lcd_str_1		;  
     f1: reti

     ;      
     ; 
     lcd_str_1:
	dec count_lcd
	brne met
     ;       
     ;,        
	ldi count_lcd,16
	ldi lcd,$01
	rcall lcdcom
	rcall delay2ms
     ;       
	ldi lcd,$C0
	rcall lcdcom
     ;        
     ;
     met: ldi zl,low(str_1*2)
	ldi zh,high(str_1*2)
	add zl,key
	brcc me2
	inc zh
     me2: lpm
	mov lcd,r0
	rcall lcddat
	ret

     ;     
     lcdcom:
	out PORTC,lcd		; 
	ldi temp,0x80		;   
	out PORTA,temp
	cbi PORTA,e		; 1/0 
	rcall delay40us
	ret

     ;     
     lcddat:
	out PORTC,lcd		; 
	ldi temp,0xA0		;   
	out PORTA,temp
	cbi PORTA,e		; 1/0 
	rcall delay40us
	ret

     delay40us:		; 40   Fclk - 3,69 
	ldi r18,48
     d0:dec r18
	brne d0
	ret

     delay2ms:		; 2 
	ldi r17,48
     d1:rcall delay40us
	dec r17
	brne d1
	ret

     ;     
     str_0: .db 'K','E','Y','P','A','D',' ','+',' ','L','C','D'
     ; ,     
     str_1: .db '/','x','-','+','9','6','3','=','8','5','2','0','7','4','1','*'